﻿// ***********************************************************************************************************************************************************
// * Copyright (c) 2008 Unit Software                                                                                                                        *
// *                                                                                                                                                         *
// * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),      *
// * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,      *
// * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:              *
// *                                                                                                                                                         *
// * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.                          *
// *                                                                                                                                                         *
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     *
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      *
// * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS    *
// * IN THE SOFTWARE.                                                                                                                                        *
// ***********************************************************************************************************************************************************
using System.ComponentModel;

namespace UnitSoftware.LINQ2SQLExtensions
{
    internal class PropertyChangeRegistration<TEntity> where TEntity : Entity
    {
        private readonly TEntity _entity;
        private readonly DataContextOperationStack _stack;

        internal PropertyChangeRegistration(TEntity entity, DataContextOperationStack stack)
        {
            _entity = entity;
            _stack = stack;

            _entity.OnPropertyChanged += _entity_PropertyChanged;
        }

        private void _entity_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            _stack.StackOperation(new DataContextOperationStack.PropertyChangedOperation(_entity, e.PropertyName));
        }
    }
}