﻿// ***********************************************************************************************************************************************************
// * Copyright (c) 2008 Unit Software                                                                                                                        *
// *                                                                                                                                                         *
// * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),      *
// * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,      *
// * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:              *
// *                                                                                                                                                         *
// * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.                          *
// *                                                                                                                                                         *
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     *
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      *
// * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS    *
// * IN THE SOFTWARE.                                                                                                                                        *
// ***********************************************************************************************************************************************************

namespace LINQ2SQLExtentionsUnitTestSuite
{
    public class DataContextFactory
    {
        public const string DEFAULT_CONNECTION_STRING = "server=(local);database=LIN2SQLExtensionsTestSuite;uid=sa;pwd=";
        
        public readonly static DataContextFactory INSTANCE = new DataContextFactory();

        private readonly DataClassesDataContext _dataContext;

        private DataContextFactory()
        {
            _dataContext = new DataClassesDataContext(DEFAULT_CONNECTION_STRING);

            if (_dataContext.DatabaseExists())
                _dataContext.DeleteDatabase();

            _dataContext.CreateDatabase();
        }

        public DataClassesDataContext GetNewDataContext()
        {
            return new DataClassesDataContext(DEFAULT_CONNECTION_STRING);
        }
    }
}