﻿// ***********************************************************************************************************************************************************
// * Copyright (c) 2008 Unit Software                                                                                                                        *
// *                                                                                                                                                         *
// * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),      *
// * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,      *
// * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:              *
// *                                                                                                                                                         *
// * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.                          *
// *                                                                                                                                                         *
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     *
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      *
// * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS    *
// * IN THE SOFTWARE.                                                                                                                                        *
// ***********************************************************************************************************************************************************

using System;
using System.Linq;
using NUnit.Framework;

namespace LINQ2SQLExtentionsUnitTestSuite
{
    [TestFixture]
    public class ExtendedDataContextTests
    {
        [Test]
        public void DeleteDeletedEntity()
        {
            var context1 = DataContextFactory.INSTANCE.GetNewDataContext();

            context1.ClearAllData();

            var invoice = new Invoice { Raised = DateTime.Now };

            context1.Invoices.InsertOnSubmit(invoice);

            context1.SubmitChanges();

            invoice = Enumerable.First(context1.Invoices);

            context1.Invoices.DeleteOnSubmit(invoice);

            var context2 = DataContextFactory.INSTANCE.GetNewDataContext();

            invoice = (Invoice)invoice.GetOnContext(context2);

            context1.SubmitChanges();

            context2.Invoices.DeleteOnSubmit(invoice);

            Assert.AreEqual(0, context2.SubmitChanges().Conflicts.Count);
        }
    }
}
